#####################################################################
##  rpud : An R packge for GPU computing
##  Copyright (C) 2010-2016 Chi Yau
##

library(e1071)
library(SparseM)

filepath <- file.path(path.package(package="rpud"), "runit/data/rpusvm/heart_scale")
hs <- read.svm.data(filepath, fac=TRUE)

x <- hs$x
y <- hs$y
y1 <- as.numeric(y)

scale <- FALSE

test.svm.sparse.basic.s0 <- function() {
	
	type <- "C-classification"
	
	model.libsvm <- e1071::svm(x, y, type=type, scale=scale)
	pred.libsvm <- fitted(model.libsvm)
	
	model.rpusvm <- rpusvm(x, y, type=type, scale=scale) 
	pred.rpusvm <- fitted(model.rpusvm)
	
	checkEquals(pred.libsvm, pred.rpusvm)
}

test.svm.sparse.basic.s1 <- function() {
	
	type <- "nu-classification"

	model.libsvm <- e1071::svm(x, y, type=type, scale=scale)
	pred.libsvm <- fitted(model.libsvm)
	
	model.rpusvm <- rpusvm(x, y, type=type, scale=scale) 
	pred.rpusvm <- fitted(model.rpusvm)
	
	checkEquals(pred.libsvm, pred.rpusvm)
}

test.svm.sparse.basic.s2 <- function() {
	
	type <- "one-classification"
	
	model.libsvm <- e1071::svm(x, y, type=type, scale=scale)
	pred.libsvm <- fitted(model.libsvm)
	
	model.rpusvm <- rpusvm(x, y, type=type, scale=scale) 
	pred.rpusvm <- fitted(model.rpusvm)
	
	checkEquals(pred.libsvm, pred.rpusvm)
}

test.svm.sparse.basic.s3 <- function() {
	
	type <- "eps-regression"
	
	model.libsvm <- e1071::svm(x, y1, type=type, scale=scale)
	pred.libsvm <- fitted(model.libsvm)
	
	model.rpusvm <- rpusvm(x, y1, type=type, scale=scale) 
	pred.rpusvm <- fitted(model.rpusvm)
	
	checkEqualsNumeric(pred.libsvm, pred.rpusvm, tolerance=1.e-03)
}

test.svm.sparse.basic.s4 <- function() {
	
	type <- "nu-regression"
	
	model.libsvm <- e1071::svm(x, y1, type=type, scale=scale)
	pred.libsvm <- fitted(model.libsvm)
	
	model.rpusvm <- rpusvm(x, y1, type=type, scale=scale) 
	pred.rpusvm <- fitted(model.rpusvm)
	
	checkEqualsNumeric(pred.libsvm, pred.rpusvm, tolerance=1.e-03)
}

.tearDown <- function() {
    flush.console()
}

